#require_dependency 'issues_helper'

module SmartIssuesSort
  module Patches
    module RenderQueriesPatch
      def self.included(base) # :nodoc:
        base.send(:include, InstanceMethods)
        base.class_eval do
          unloadable
          alias_method_chain :render_sidebar_queries, :category
        end
      end

      module InstanceMethods
        def render_sidebar_queries_with_category
          out = ''.html_safe
          unless sidebar_queries.empty?
            out << "<h3>#{l(:label_query_plural)}</h3>"
            sidebar_queries.group_by {|q| q.category || "" }.sort.each do |query_group_name, queries|
              unless query_group_name.empty?
                out << "<h4>#{query_group_name}</h4>"
              end
              queries.each do |query|
                for_all_projects = query.project.nil? ? true : false
                link_to_hash={:controller => 'issues', :action => 'index', :query_id => query, :project_id => nil }
                unless for_all_projects
                  link_to_hash[:project_id]=@project
                  query.project = @project unless @project.nil?
                end
                out << link_to(h(query.name), link_to_hash, :class => (query.is_public? ? 'icon icon-fav-off' : 'icon icon-fav'))
                if for_all_projects && @project != nil
                  link_to_hash[:project_id]=@project
                  query.project = @project
                  out << "[#{link_to('L', link_to_hash)}]"
                  issue_count = ''
                else
                  issue_count = "(#{query.issue_count.to_s rescue '???'})"
                end
                out << "#{issue_count}<br />"
              end
            end
          end
          out
        end
      end
    end
  end
end
